--interpolation utilities
-- by minenice

rawset(_G, "TableLerp", {})

local flerp_p, flerp_a, flerp_b, flerp_u, flerp_v, flerp_x, flerp_y
function TableLerp.flerp(num, denum, minimum, maximum)
	flerp_p = FixedDiv(num, denum)
	flerp_a = FixedMul((maximum - minimum), flerp_p)
	return minimum + flerp_a
end

function TableLerp.bezier(num, denum, minimum, maximum, middle)
	flerp_p = FixedDiv(num, denum)
	flerp_x = TableLerp.flerp(flerp_p, FRACUNIT, minimum, middle)
	flerp_y = TableLerp.flerp(flerp_p, FRACUNIT, middle, maximum)
	return TableLerp.flerp(flerp_p, FRACUNIT, flerp_x, flerp_y)
end

function TableLerp.inQuart(num, denum, minimum, maximum)
	flerp_p = FixedDiv(num, denum)
	flerp_x = FixedMul(flerp_p, flerp_p)
	flerp_y = FixedMul(flerp_x, flerp_x)
	flerp_a = FixedMul((maximum - minimum), flerp_y)
	return minimum + flerp_a
end

function TableLerp.outQuart(num, denum, minimum, maximum)
	flerp_p = FRACUNIT - FixedDiv(num, denum)
	flerp_x = FixedMul(flerp_p, flerp_p)
	flerp_y = FRACUNIT - FixedMul(flerp_x, flerp_x)
	flerp_a = FixedMul((maximum - minimum), flerp_y)
	return minimum + flerp_a
end

function TableLerp.inQuad(num, denum, minimum, maximum)
	flerp_p = FixedDiv(num, denum)
	flerp_x = FixedMul(flerp_p, flerp_p)
	flerp_a = FixedMul((maximum - minimum), flerp_x)
	return minimum + flerp_a
end

function TableLerp.outQuad(num, denum, minimum, maximum)
	flerp_p = FixedDiv(num, denum)
	flerp_x = FRACUNIT - FixedMul(FRACUNIT - flerp_p, FRACUNIT - flerp_p)
	flerp_a = FixedMul((maximum - minimum), flerp_x)
	return minimum + flerp_a
end

function TableLerp.inCubic(num, denum, minimum, maximum)
	flerp_p = FixedDiv(num, denum)
	flerp_x = FixedMul(FixedMul(flerp_p, flerp_p), flerp_p)
	flerp_a = FixedMul((maximum - minimum), flerp_x)
	return minimum + flerp_a
end

function TableLerp.outCubic(num, denum, minimum, maximum)
	flerp_p = FixedDiv(num, denum)
	flerp_x = FRACUNIT - flerp_p
	flerp_y = FRACUNIT - FixedMul(FixedMul(flerp_x, flerp_x), flerp_x)
	flerp_a = FixedMul((maximum - minimum), flerp_y)
	return minimum + flerp_a
end

--table formatted as {{location, value}, {location, value}, ...}
function TableLerp.tableLerp(prog, table)
	if not table then
		return 0
	end
	for k = 1, #table - 1 do
		if table[k][1] <= prog then
			flerp_u = table[k][1]
			flerp_v = table[k][2]
			flerp_x = table[k + 1][1]
			flerp_y = table[k + 1][2]
		end
	end
	return TableLerp.flerp(prog - flerp_u, flerp_x - flerp_u, flerp_v, flerp_y)
end